/**
*--------------------------拍摄仪--------------------------
**/
//声明分辨率数组
var resolutionCamArray = new Array;

//声明拍摄仪数组
var videonameCamArray = new Array;

//视频显示的宽
var videoShowW;
//视频显示的高
var videoShowH;
//视频旋转角度
var nVideoRotateAngle = 0;
//当前选择的摄像头
var devNum = 0;

//上一个摄像头
var predevNum =0;

var nclientHeight;
//当前拍摄图片的存储路径
var currentCameraName;

//初始化信息
$(function () { 
    //获取拍摄仪参数
    GetCameraInfo("");
	//初始化图片列表的高度
    initImageDataHeight();
})

//初始化图片列表的高度
function initImageDataHeight(){
    var nclientHeight = document.body.clientHeight-20;//容器区域尺寸
    $("#right_div").css('height',nclientHeight+'px');
}

//设备信息的onchange事件
function switchCameraInfo_Fun(nType){

       
    if(nType == 0||nType == 1){
		//设备的值 
		getCameraNum_Fun();
        //关闭摄像头
        closeCamera_Fun(nType);
    }



    //添加摄像头名称
    setDevName_Fun();

    //根据选择的设备信息,设置分辨率
    setResolution_Fun();
    //根据设备信息和分辨率信息设置设备信息
   
    setCameraInfo_Fun(devNum);
}

//开启摄像头
function openCamera_Fun(){
    var enable = "true";
    GetCameraVideoBuff("",parseInt(devNum),enable);
	//开启摄像头
    OpenCamera("",parseInt(devNum)); 
}

//关闭摄像头
function closeCamera_Fun(nType){
    var enable = "false";

    GetCameraVideoBuff("",parseInt(devNum),enable);
	//关闭摄像头
    CloseCamera("",parseInt(devNum)); 
}

//获取摄像头
function getCameraNum_Fun(){
	//设备的值 

 
    devNum = $("#cameraInfo").val() == null ? 0 : $("#cameraInfo").val();


    console.log("current devNum: "+devNum);


}

function currentDateString(){
    var myDate = new Date();
    var year = myDate.getFullYear();
    var month = myDate.getMonth()+1;
    var date = myDate.getDate();
    var hour = myDate.getHours();
    var minute = myDate.getMinutes();
    var second = myDate.getSeconds();
    var millSecond = myDate .getMilliseconds();

   
    var currentDateString = year+""+month+""+date+""+hour+""+minute+""+second+""+millSecond;


    return currentDateString;
}

function cameraCaptureBase_Fun(){
    currentCameraName = currentDateString();
    //根据设备信息和分辨率信息设置设备信息
    // setCameraInfo_Fun();
    ////设置图像算法
    setCameraImageInfo_Fun();
    //高拍仪拍照接口
    currentCameraName = $("#storage_path").val() + "/" + currentCameraName + ".jpg";
    CameraCapture("",parseInt(devNum),currentCameraName);
}

//初始化设备信息
function initCameraInfo_Fun(devInfoList){
    for(var i = 0;i < devInfoList.length; i++){
        var devInfo = devInfoList[i];
        console.log(devInfo);
        document.getElementById("cameraInfo").options.add(new Option(devInfo.devName, i));
        //存储设备的分辨率列表
        resolutionCamArray.push(devInfo.resolutionList); 

        //存储设备的拍摄仪名称列表
        videonameCamArray.push(devInfo.devName); 

    }
}


//设置设备信息
function setCameraInfo_Fun(nType){


    if(nType == 0||nType == 1){
        //关闭摄像头
        closeCamera_Fun();
    }


    //分辨率的值
    var resolutionNum = $("#resolution").val() == null ? 0 : $("#resolution").val();

    console.log("---fenbianlv:"+resolutionNum);
    //设置设备信息
    SetCameraInfo("",parseInt(devNum),0,parseInt(resolutionNum));  


}

//初始化分辨率信息
function setResolution_Fun(){
    //清空resolution:select数据
    document.getElementById("resolution").options.length = 0;
    //声明分辨率列表并赋值
    // var resolutionList = resolutionCamArray[devNum];
    var resolutionList = resolutionCamArray[0];
    for(var i = 0;i < resolutionList.length; i++){  
       document.getElementById("resolution").options.add(new Option(resolutionList[i], i));
    }
}



//初始化摄像头名称信息
function setDevName_Fun(){

    if(devNum == 0)
    {
        //清空resolution:select数据
        document.getElementById("cameraInfo").options.length = 0;
        var videonameList = videonameCamArray[devNum];
        for(var i = devNum;i < videonameList.length; i++){  
        document.getElementById("cameraInfo").options.add(new Option(videonameList[i], i));
        }
    }


}




/**设置图像算法
    CropType 裁切：0-不裁切  1-单图裁切　２－多图裁切　３－曲面矫正
    ImageType 图像效果：0-彩色原色 1-灰度图片 2-黑白文档　３－　彩色文档　４－红印文档　５－蓝印文档　６－彩色照片　７－票据增强
    FillBorderType 补边：0-不填充 1-自动填充白色　２－自动填充周边色
    RemovalForeign 异物去除　０-无　1-去除手指　２－去除装订孔
**/
function setCameraImageInfo_Fun(){
    var cropType = $("#crop_type").val();
    //曲面矫正需要显示中间绿色线条
    showMiddleLine_Fun(cropType);
    var imageType = $("#image_type").val();
    var fillBorderType = $("#fill_border").val();
    var removalForeign = $("#foreign_remove").val();
    SetCameraImageInfo("",parseInt(devNum),parseInt(cropType),parseInt(imageType),parseInt(fillBorderType),parseInt(removalForeign),nVideoRotateAngle);
}

//曲面矫正需要显示中间绿色线条
function showMiddleLine_Fun(cropType){
    if(cropType == 3){
        var nclientWidth = document.body.clientWidth-400;
        nclientWidth = nclientWidth/2; 
        $("#vertical-line").css('width',nclientWidth+'px');
        $("#vertical-line").show();
    }else{
        $("#vertical-line").hide();
    }
}

//旋转
function rotateVideo_Fun(){
    
    nVideoRotateAngle = nVideoRotateAngle + 90;
    if(nVideoRotateAngle >= 360){
        nVideoRotateAngle = 0;
    }
    setCameraImageInfo_Fun();
}

//计算视频显示宽　高
function calculateVideoSize_Fun(contentW,contentH,videoBuffW,videoBuffH){
    //视频buff的宽高比
    var videoWHProportion = videoBuffW / videoBuffH; 

   if(contentW < contentH){
        videoShowW = contentH;
        videoShowH = videoShowW / videoWHProportion;
    }
    else{
        videoShowH = contentH;
        videoShowW = videoShowH * videoWHProportion;
    }           
}

//添加图片项并展示列表
function addImageItem_Fun(currentCameraName){
    calculateVideoSize_Fun(90,70,videoShowW,videoShowH);     
    var image = '<div width="90" height="75"><img width="'+videoShowW+'" height="'+videoShowH+'" style="padding: 5px 5px 5px 5px;" src="'+currentCameraName+'"></div>';
    $("#image_data").append(image);
}

//上传文件
function Uploadfile_Fun(tmpurl,tmpfilepath){
    var url =$("#URL").val();
    var filepath=$("#FilePath").val();
    UploadCamFile(url,filepath);
}

//接收并处理后台发送的信息
function produceMessage(jsonObj) {
    //如果返回信息存在errorMsg，并且不为空则弹出错误信息
    if(jsonObj.errorMsg != null){
        alert(jsonObj.errorMsg);
        return;
    }

    var funcName = jsonObj.func;
    console.log("方法名称为"+funcName);
    if(funcName=="GetCameraInfo"){
        var devInfoList = jsonObj.devInfo;
        if(devInfoList.length == 0){
            alert("高拍仪设备信息为空");
            return;
        }




        console.log("初始化设备信息 00");
        //初始化设备信息
        initCameraInfo_Fun(devInfoList);
        console.log("初始化设备信息 01");


         console.log("switchCameraInfo_Fun :"+ devNum);

         switchCameraInfo_Fun(devNum);
        // switchCameraInfo_Fun(1);
        console.log("初始化设备信息End");
    }
    else if(funcName=="SetCameraInfos"){
           console.log("SetCameraInfos"+jsonObj.result); 
    }
    else if(funcName=="OpenCamera"){
           console.log("OpenCamera"+jsonObj.result);
    }
    else if(funcName=="SetCameraImageInfo"){
           console.log("SetCameraImageInfo"+jsonObj.result);
    }
    else if(funcName=="CloseCamera"){
        console.log("CloseCamera"+jsonObj.result);  
    }
    else if(funcName=="GetCameraVideoBuff"){
        var videoStr = jsonObj.imgBase64Str;
        if (videoStr == null){
            alert("视频流base64为空");
            return;
        }

        //根据容器显示区域尺寸和视频实际尺寸，计算视频显示尺寸
        var nclientHeight = document.body.clientHeight-90;//容器区域尺寸

        var nclientWidth = document.body.clientWidth-400;
        var nVideoWidth = jsonObj.Width;//视频Buff尺寸
        var nVideoHeight = jsonObj.Height;

        //计算视频显示宽　高
        calculateVideoSize_Fun(nclientWidth,nclientHeight,nVideoWidth,nVideoHeight); 
        //设置视频控件的宽高
        $("#pic").css('width',videoShowW+'px');
        $("#pic").css('height',videoShowH+'px'); 

        var myimg = document.getElementById("pic");
        //显示视频
        myimg.src = "data:image/png;base64," + videoStr;      

    }
    else if(funcName=="CameraCapture"){
        //添加图片项并展示列表    
        addImageItem_Fun(currentCameraName);
		console.log("base64:"+jsonObj.base64); 

       // UploadCamFile($("#URL").val(),jsonObj.reqId);
    }
    else if(funcName=="UploadCamFile"){
        //添加图片项并展示列表    
        addImageItem_Fun(currentCameraName);
    }
}


    //心跳检测
    var heartCheck = {
        timeout: 3000,
        timeoutObj: null,
        serverTimeoutObj: null,
        start: function(){
          console.log('start');
          var self = this;
          this.timeoutObj && clearTimeout(this.timeoutObj);
          this.serverTimeoutObj && clearTimeout(this.serverTimeoutObj);
          this.timeoutObj = setTimeout(function(){
            //这里发送一个心跳，后端收到后，返回一个心跳消息，
            console.log('55555');
            ws.send("123456789");
            self.serverTimeoutObj = setTimeout(function() {
              console.log(111);
              console.log(ws);
              ws.close();
              // createWebSocket();
            }, self.timeout);
  
          }, this.timeout)
        }
      }


